﻿--
-- Heath SuperChaser
--
-- author Mythos
-- date  20/06/2011
-- www.Virtual-Farmers.gr
-- Copyright (C) ARM Team, All Rights Reserved.

Heath = {};
--________________________________________________________________________________________________________________________________________________________
function Heath.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:load(xmlFile)

	-- Functions
	self.WorkMode= SpecializationUtil.callSpecializationsFunction("WorkMode");
	self.PrepareMode= SpecializationUtil.callSpecializationsFunction("PrepareMode");
	self.LoadMode= SpecializationUtil.callSpecializationsFunction("LoadMode");
	self.UnloadMode= SpecializationUtil.callSpecializationsFunction("UnloadMode");
	self.FiHeBa= SpecializationUtil.callSpecializationsFunction("FiHeBa");
	
	self.FiDi= SpecializationUtil.callSpecializationsFunction("FiDi");
	
	self.createBale = SpecializationUtil.callSpecializationsFunction("createBale");
	self.dropBale = SpecializationUtil.callSpecializationsFunction("dropBale");
	
	-- Animations
	self.workmodeEven = getXMLString(xmlFile, "vehicle.workmodeEven#animationName");
	self.workmodeOdd = getXMLString(xmlFile, "vehicle.workmodeOdd#animationName");
	self.workmodeZero = getXMLString(xmlFile, "vehicle.workmodeZero#animationName");
	self.transportmodeEven = getXMLString(xmlFile, "vehicle.transportmodeEven#animationName");
	self.transportmodeOdd = getXMLString(xmlFile, "vehicle.transportmodeOdd#animationName");
	self.transportmodeFull = getXMLString(xmlFile, "vehicle.transportmodeFull#animationName");
	
	self.transportUnloaded = getXMLString(xmlFile, "vehicle.transportUnloaded#animationName");
	self.transportUnloadedFull = getXMLString(xmlFile, "vehicle.transportUnloadedFull#animationName");
	self.transportUnloadedEven = getXMLString(xmlFile, "vehicle.transportUnloadedEven#animationName");
	self.transportSlider = getXMLString(xmlFile, "vehicle.transportSlider#animationName");
	
	self.preparefromOdd = getXMLString(xmlFile, "vehicle.preparefromOdd#animationName");
	self.preparefromEven = getXMLString(xmlFile, "vehicle.preparefromEven#animationName");
	self.preparefromFull = getXMLString(xmlFile, "vehicle.preparefromFull#animationName");
	
	self.loadEven2 = getXMLString(xmlFile, "vehicle.loadEven2#animationName");
	self.loadEven4 = getXMLString(xmlFile, "vehicle.loadEven4#animationName");
	self.loadEven6 = getXMLString(xmlFile, "vehicle.loadEven6#animationName");
	self.loadEven8 = getXMLString(xmlFile, "vehicle.loadEven8#animationName");
	self.loadOdd = getXMLString(xmlFile, "vehicle.loadOdd#animationName");
	self.loadFull = getXMLString(xmlFile, "vehicle.loadFull#animationName");
	
	self.unload = getXMLString(xmlFile, "vehicle.unload#animationName");
	
	self.step1 = getXMLString(xmlFile, "vehicle.step1#animationName");
	self.step2 = getXMLString(xmlFile, "vehicle.step2#animationName");
	self.step3 = getXMLString(xmlFile, "vehicle.step3#animationName");
	self.step4 = getXMLString(xmlFile, "vehicle.step4#animationName");
	
	self.slide1 = getXMLString(xmlFile, "vehicle.slide1#animationName");
	self.slide2 = getXMLString(xmlFile, "vehicle.slide2#animationName");
	self.slide3 = getXMLString(xmlFile, "vehicle.slide3#animationName");
	self.slide4 = getXMLString(xmlFile, "vehicle.slide4#animationName");

	-- Indexs
	self.base = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.base#index"));
	self.slider = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.slider#index"));
	self.balesJoint = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.balesJoint#index"));
	self.ref = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.baleRef#index"));
	
	self.spikeJoint = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Spikes#joint"));
	self.haySpike = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Spikes#hay"));
	self.strawSpike = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Spikes#straw"));
	self.haySpikeEven = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Spikes#hayEven"));
	self.strawSpikeEven = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Spikes#strawEven"));
	
	self.linkOddBale = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.loadedBales.bale1#index"));
	self.linkEvenBale = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.loadedBales.bale2#index"));
	
	self.hayBaleFilename = getXMLString(xmlFile, "vehicle.bales.bale1#filename");
	self.strawBaleFilename = getXMLString(xmlFile, "vehicle.bales.bale2#filename");
	
	-- Particles
	self.sParticles = {};
	local i = 0;
    while true do
        local key = string.format("vehicle.sParticles.pSystem(%d)", i);
		local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "#index"));
		if node == nil then
			break;
		end; 
        Utils.loadParticleSystem(xmlFile, self.sParticles, key, node, false, nil, self.baseDirectory)		
		i = i +1;		
    end;
	self.hParticles = {};
	local i = 0;
    while true do
        local key = string.format("vehicle.hParticles.pSystem(%d)", i);
		local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "#index"));
		if node == nil then
			break;
		end; 
        Utils.loadParticleSystem(xmlFile, self.hParticles, key, node, false, nil, self.baseDirectory)		
		i = i +1;		
    end;
	
	-- Bale Types
	self.baleTypes = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.baleTypes.bale(%d)", i);
		if not hasXMLProperty(xmlFile, key) then
			break;
		end;
		local filename = getXMLString(xmlFile, key.."#type");
		if filename ~= nil then
			table.insert(self.baleTypes, filename);
		end;
		i = i + 1;
	end;

	-- Bales Loaded Tables
	self.hayBales = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.hayBales.bale(%d)", i);
		if not hasXMLProperty(xmlFile, key) then
			break;
		end;
		local index = Utils.indexToObject(self.components,getXMLString(xmlFile, key.."#index"));
		if index ~= nil then
			table.insert(self.hayBales, index);
		end;
		i = i + 1;
	end;
		
	self.strawBales = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.strawBales.bale(%d)", i);
		if not hasXMLProperty(xmlFile, key) then
			break;
		end;
		local index = Utils.indexToObject(self.components,getXMLString(xmlFile, key.."#index"));
		if index ~= nil then
			table.insert(self.strawBales, index);
		end;
		i = i + 1;
	end;
	
	-- Booleans
	self.i = {};
	self.workMode = false;
	self.prepareMode = false;
	self.unloadMode = false;
	self.unloaded = false;
	
	self.counter = 0;
	self.animEnded = true;
	self.foundIt = false;
	self.baleId = nil;
	self.fruitBale = nil;
	
	self.old_dif = 0;
	
	self.okai = false;
	self.okai2 = false;
	self.okai3 = false;
	
	self.itsOver = false;
	self.itsOver2 = false;
	self.itsOver3 = false;
	self.endGame = false;
	self.ready2go = false;
	self.abort = false;
	self.tranprep = false;

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:delete()
	Utils.deleteParticleSystem(self.hParticles);
	Utils.deleteParticleSystem(self.sParticles);
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:mouseEvent(posX, posY, isDown, isUp, button)

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:keyEvent(unicode, sym, modifier, isDown)

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:update(dt)

if self:getIsActiveForInput() then
	if self.animEnded then
		if self.unloadMode then
			if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
				self:UnloadMode(not self.unloadMode);
			end;
		elseif self.unloaded then
			if not self.endGame then
				if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
					self.abort = true;
					self:WorkMode(not self.unloaded);
				end;
				if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
					self:dropBale();
				end;
			elseif self.ready2go then
				if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
					self:WorkMode(not self.unloaded);
				end;
			end;
		else
			if self.abort then
				if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
					self:PrepareMode(not self.prepareMode);
				end;
			else
				if self.counter == 10 and not self.workMode then
					if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
						self:PrepareMode(not self.prepareMode);
					end;
				else
					if not self.workMode then
						if self.counter == 0 or self.counter == 10 then
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
								self:WorkMode(not self.workMode);
							end;
						else
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
								self:WorkMode(not self.workMode);
							end;
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
								self:PrepareMode(not self.prepareMode);
							end;
						end;
					else
						if self.counter == 10 then
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
								self:WorkMode(not self.workMode);
							end;
						else
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
								self:WorkMode(not self.workMode);
							end;
							if self.foundIt then
								if math.mod(self.counter, 2) == 0 then
									if self.fruitBale:lower():find("hay") ~= nil then
										self.fruitBale = "hay";
										self.baleSpike = self.haySpike;
										self.filename = self.hayBaleFilename;
									else
										self.fruitBale = "straw";
										self.baleSpike = self.strawSpike;
										self.filename = self.strawBaleFilename;
									end;
								else
									if self.fruitBale:lower():find("hay") ~= nil then
										self.fruitBale = "hay";
										self.baleSpike = self.haySpikeEven;
										self.filename = self.hayBaleFilename;
									else
										self.fruitBale = "straw";
										self.baleSpike = self.strawSpikeEven;
										self.filename = self.strawBaleFilename;
									end;
								end;
								
								self:LoadMode(self.baleSpike);
							else
								self:FiHeBa(self.spikeJoint);
							end;
						end;
					end;
				end;
			end;
		end;
	end;

	for name,v in pairs(self.animations) do
		if self.activeAnimations[name] ~= nil then
			self.animEnded = false;
			self.animName = name;
			break;
		else
			self.animEnded = true;
			self.animName = nil;
			self.itsOver = false;
			self.itsOver2 = false;
			self.itsOver3 = false;
		end;
	end;
	
	if self.fruitBale == "hay" then
		self.i = self.hParticles;
	else
		self.i = self.sParticles;
	end;
	if self.animName ~= nil and self.animName == "WorkModeOdd" and not self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 2500 then
			Utils.setEmittingState(self.i, true);
			self.okai2 = true;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "WorkModeOdd" and self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 3100 then
			Utils.setEmittingState(self.i, false);
			self.okai2 = false;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "WorkModeEven" and not self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 2500 then
			Utils.setEmittingState(self.i, true);
			self.okai2 = true;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "WorkModeEven" and self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 3100 then
			Utils.setEmittingState(self.i, false);
			self.okai2 = false;
		end;
	end;

	if not self.tranprep then
		if self.animName ~= nil and self.animName == "PrepareModeEven" and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 0 then
				Utils.setEmittingState(self.i, true);
				self.okai2 = true;
			end;
		end;
		
		if self.animName ~= nil and self.animName == "PrepareModeEven" and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 600 then
				Utils.setEmittingState(self.i, false);
				self.okai2 = false;
			end;
		end;
	end;
	
	if self.tranprep == false or (self.tranprep and self.counter == 9) then
		if self.animName ~= nil and self.animName == "PrepareModeOdd" and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 0 then
				Utils.setEmittingState(self.i, true);
				self.okai2 = true;
			end;
		end;
			
		if self.animName ~= nil and self.animName == "PrepareModeOdd" and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 600 then
				Utils.setEmittingState(self.i, false);
				self.okai2 = false;
			end;
		end;		
	end;
	
	if self.animName ~= nil and self.animName == "PrepareModeFull" and not self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 0 then
			Utils.setEmittingState(self.i, true);
			self.okai2 = true;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "PrepareModeFull" and self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 600 then
			Utils.setEmittingState(self.i, false);
			self.okai2 = false;
		end;
	end;

	if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8) and not self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 0 then
			Utils.setEmittingState(self.i, true);
			self.okai2 = true;
		end;
	end;
	
	if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8) and self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 3000 then
			Utils.setEmittingState(self.i, false);
			self.okai2 = false;
		end;
	end;
	
	if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8) and not self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 6000 then
			Utils.setEmittingState(self.i, true);
			self.okai2 = true;
		end;
	end;
	
	if self.animName ~= nil and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8) and self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 6600 then
			Utils.setEmittingState(self.i, false);
			self.okai2 = false;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "LoadModeOdd" and not self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 0 then
			Utils.setEmittingState(self.i, true);
			self.okai2 = true;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "LoadModeOdd" and self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 2000 then
			Utils.setEmittingState(self.i, false);
			self.okai2 = false;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "LoadModeOdd" and not self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 2500 then
			Utils.setEmittingState(self.i, true);
			self.okai2 = true;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "LoadModeOdd" and self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 3100 then
			Utils.setEmittingState(self.i, false);
			self.okai2 = false;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "LoadModeFull" and not self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 0 then
			Utils.setEmittingState(self.i, true);
			self.okai2 = true;
		end;
	end;
	
	if self.animName ~= nil and self.animName == "LoadModeFull" and self.okai2 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 2900 then
			Utils.setEmittingState(self.i, false);
			self.okai2 = false;
		end;
	end;
	
	if not self.itsOver3 and (self.animName == self.preparefromFull or self.animName == self.preparefromEven or self.animName == self.preparefromOdd) then
		self.animTime = self:getAnimationTime(self.animName);
		if self.animTime >0.8 then	
			if self.counter ==1 then
				self:playAnimation(self.slide1, 1, nil, true);
			elseif self.counter ==2 or self.counter ==3 then
				self:playAnimation(self.slide2, 1, nil, true);
			elseif self.counter ==4 or self.counter ==5 then
				self:playAnimation(self.slide3, 1, nil, true);
			elseif self.counter ==6 or self.counter ==7 then
				self:playAnimation(self.slide4, 1, nil, true);
			end;
		self.itsOver3 = true;
		end;
	
	end;
	
	if self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8 then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 3000 and not self.itsOver then
			self.full = false;
			self.even = true;
			self.odd = false;
			setVisibility(self.baleSpike, false);
			
			if self.fruitBale == "hay" then
				local i = self.counter;
				setVisibility(self.hayBales[i], true);
			else
				local i = self.counter;
				setVisibility(self.strawBales[i], true);
			end;
			self.itsOver = true;
		end;
	end;
	
	if self.animName == self.loadOdd and not self.itsOver then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 2000 then
			setVisibility(self.baleSpike, false);
			
			if self.fruitBale == "hay" then
				local i = self.counter;
				setVisibility(self.hayBales[i], true);
			else
				local i = self.counter;
				setVisibility(self.strawBales[i], true);
			end;
			self.itsOver = true;
		end;
	end;
	
	if self.animName == self.loadFull and not self.itsOver then
		self.animTime = self:getRealAnimationTime(self.animName);
		if self.animTime > 2900 then
			setVisibility(self.baleSpike, false);

			if self.fruitBale == "hay" then
				local i = self.counter;
				setVisibility(self.hayBales[i], true);
			else
				local i = self.counter;
				setVisibility(self.strawBales[i], true);
			end;
			self.itsOver = true;
		end;
	end;

	if self.endGame and not self.okai then
		local refx, refy, refz = getWorldTranslation(self.ref);
		local bx, by, bz = getWorldTranslation(self.baleId2);
		self.sdiff = Utils.vector3Length(refx-bx, refy-by, refz-bz);
		self.sliderConfffz = refz-bz;
		self.sliderConfffx = refx-bx;
		self.okai = true;
	end;
	
	if self.endGame and not self.ready2go then
		local refx, refy, refz = getWorldTranslation(self.ref);
		local bx, by, bz = getWorldTranslation(self.baleId2);
		local diff = Utils.vector3Length(refx-bx, refy-by, refz-bz);
		
		local sliderConfz = refz-bz;
		local sliderConfx = refx-bx;
		
		local dif = diff - self.sdiff;
		if dif > 2 then
			self:playAnimation(self.transportSlider, 1, nil, true);
			self.old_dif = 0;
			self.ready2go = true;
		elseif dif < 1.3 then
			if self.sliderConfffz ~= 0 then
				if self.sliderConfffz > 0 then
					if sliderConfz > self.sliderConfffz then
						if dif ~= self.old_dif then
							translate(self.slider, 0, 0, -(dif-self.old_dif));
							self.old_dif = dif;
						end;
					end;
				else
					if sliderConfz < self.sliderConfffz then
						if dif ~= self.old_dif then
							translate(self.slider, 0, 0, -(dif-self.old_dif));
							self.old_dif = dif;
						end;
					end;
				end;
			else
				if self.sliderConfffx > 0 then
					if sliderConfx > self.sliderConfffx then
						if dif ~= self.old_dif then
							translate(self.slider, 0, 0, -(dif-self.old_dif));
							self.old_dif = dif;
						end;
					end;
				else
					if sliderConfx < self.sliderConfffx then
						if dif ~= self.old_dif then
							translate(self.slider, 0, 0, -(dif-self.old_dif));
							self.old_dif = dif;
						end;
					end;
				end;	
			end;
		end;
	end;	

	for i, v in pairs(self.componentJoints) do
		setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
	end;
end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:updateTick(dt)

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:draw()

if self.animEnded then
	if self.unloadMode then
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOADMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
	elseif self.unloaded then
		if not self.endGame then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("ABORT"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
		elseif self.ready2go then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TRANSPORTMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
		end;
	else
		if self.abort then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);	
		else
			if self.counter == 10 and not self.workMode then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
			else
				if not self.workMode then
					if self.counter == 0 then
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
					else
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
					end;
				else
					if	self.counter == 10 then
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TRANSPORTMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
					else
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TRANSPORTMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
					end;
				end;
			end;
		end;
	end;
end;
	
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:WorkMode(state,noEventSend)
	WorkModeEvent.sendEvent(self, state, noEventSend);
	if state then
		if math.mod(self.counter, 2) == 0 then
			if self.counter == 0 then
				self:playAnimation(self.workmodeZero, 1, nil, true);
				self.workMode = true;
			else
				self:playAnimation(self.workmodeOdd, 1, nil, true);
				self.workMode = true;
			end;
		else
			self:playAnimation(self.workmodeEven, 1, nil, true);
			self.workMode = true;
		end;
	else
		if self.unloaded then
			if self.counter == 10 then
				self:playAnimation(self.transportUnloadedFull, 1, nil, true);
				self.unloaded = false;
				self.ready2go = false;
				self.endGame = false;
				self.okai = false;
			elseif self.counter == 8 then
				self:playAnimation(self.transportUnloadedEven, 1, nil, true);
				self.unloaded = false;
				self.ready2go = false;
				self.endGame = false;
				self.okai = false;
			elseif self.counter == 0 then
				self:playAnimation(self.transportUnloaded, 1, nil, true);
				self.unloaded = false;
				self.ready2go = false;
				self.endGame = false;
				self.okai = false;
			else
				self:playAnimation(self.transportUnloaded, 1, nil, true);
				self.unloaded = false;
				self.ready2go = false;
				self.endGame = false;
				self.okai = false;
				self.tranprep = true;
			end;		
			
		elseif math.mod(self.counter, 2) == 0 then
			if self.counter == 0 then
				self:playAnimation(self.workmodeZero, -1, nil, true);
				self.workMode = false;
				self.foundIt = false;
			elseif self.counter == 10 then
				self:playAnimation(self.transportmodeFull, 1, nil, true);
				self.workMode = false;
				self.foundIt = false;
			else
				self:playAnimation(self.transportmodeEven, 1, nil, true);
				self.workMode = false;
				self.foundIt = false;
			end;
		else
			self:playAnimation(self.transportmodeOdd, 1, nil, true);
			self.workMode = false;
			self.foundIt = false;
		end;
	end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:PrepareMode(state,noEventSend)
	PrepareModeEvent.sendEvent(self, state, noEventSend);
	if self.counter == 10 then
		self:playAnimation(self.preparefromFull, 1, nil, true);
		self.unloadMode = true;
		self.abort = false;
	elseif math.mod(self.counter, 2) == 0 then
		self:playAnimation(self.preparefromEven, 1, nil, true);
		self.unloadMode = true;
		self.abort = false;
	else
		self:playAnimation(self.preparefromOdd, 1, nil, true);
		self.unloadMode = true;
		self.abort = false;
	end;
	
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:UnloadMode(state,noEventSend)
	UnloadModeEvent.sendEvent(self, state, noEventSend);

	self:playAnimation(self.unload, 1, nil, true);
	self.unloadMode = false;
	self.unloaded = true;
	self.foundIt = false;
	
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:LoadMode(state, noEventSend)
	LoadModeEvent.sendEvent(self, state, noEventSend);
	
	if self.counter == 9 then
			local object = g_currentMission:getNodeObject(self.baleId);
			object:delete();
			setVisibility(state, true);
			self:playAnimation(self.loadFull, 1, nil, true);
			self.counter = self.counter + 1;
			self.foundIt = false;
	elseif math.mod(self.counter, 2) == 0 then
			local object = g_currentMission:getNodeObject(self.baleId);
			object:delete();
			setVisibility(state, true);
			self:playAnimation(self.loadOdd, 1, nil, true);
			self.counter = self.counter + 1;
			self.foundIt = false;
	else
			local object = g_currentMission:getNodeObject(self.baleId);
			object:delete();
			setVisibility(state, true);
			if self.counter ==1 then
				self:playAnimation(self.loadEven2, 1, nil, true);
			elseif self.counter ==3 then
				self:playAnimation(self.loadEven4, 1, nil, true);
			elseif self.counter ==5 then
				self:playAnimation(self.loadEven6, 1, nil, true);
			elseif self.counter ==7 then
				self:playAnimation(self.loadEven8, 1, nil, true);
			end;
			self.counter = self.counter + 1;
			self.foundIt = false;
	end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:FiDi(node,noEventSend)
	local x,y,z = localDirectionToWorld(node, 0, 0, 1);
	local length = Utils.vector2Length(x,z);
	local dX = x/length;
	local dZ = z/length;
	local JointDir = math.deg(math.atan2(dX,dZ)); 
	if JointDir < 0 then
		JointDir = 360 - (JointDir * -1);
	end;
	self.objDir = JointDir;

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:FiHeBa(LoadJoint,noEventSend)
	
	local px, py, pz = getWorldTranslation(LoadJoint);
	local nearestDistance = 1;
	local nearestBale = nil;
	
	for index, item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale) then
			for i, baleType in pairs(self.baleTypes) do
				if getName(item.item.nodeId) == baleType then
					local bx, by, bz = getWorldTranslation(item.item.nodeId);
					local distance = Utils.vector3Length(px-bx, py-by, pz-bz);
					if distance < nearestDistance then
						self.baleId = item.item.nodeId;
						self:FiDi(self.baleId);
						self.baleDir = self.objDir;
						self:FiDi(LoadJoint);
						self.spikeDir = self.objDir;
						self.dif = self.spikeDir - self.baleDir;
						if math.abs(self.dif) <=45 or (180-math.abs(self.dif)) <=45 then
							self.foundIt = true;
							self.baleId = item.item.nodeId;
							self.fruitBale = baleType;
						else
							self.foundIt = false;
							self.baleId = nil;
							self.fruitBale = nil;
						end;
					end;
					break;
				end;
			end;
			if self.foundIt then
				break;
			end;
		end;
	end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:dropBale()
	for i,v in pairs(self.hayBales) do
		if getVisibility(v) then
			if self.isServer then
				self.filename = self.hayBaleFilename;
				local baleObject = Bale:new(self.isServer, self.isClient);
				local objectFilename = Utils.getFilename(self.filename, self.baseDirectory);
				local x,y,z = getWorldTranslation(v);
				local rx,ry,rz = getWorldRotation(v);
				baleObject:load(objectFilename, x,y,z,rx,ry,rz);
				baleObject:register();
			end;
		end;
	end;
	
	for i,v in pairs(self.strawBales) do
		if getVisibility(v) then
			if self.isServer then
				self.filename = self.strawBaleFilename;
				local baleObject = Bale:new(self.isServer, self.isClient);
				local objectFilename = Utils.getFilename(self.filename, self.baseDirectory);
				local x,y,z = getWorldTranslation(v);
				local rx,ry,rz = getWorldRotation(v);
				baleObject:load(objectFilename, x,y,z,rx,ry,rz);
				baleObject:register();
			end;
		end;
	end;

	for i,v in pairs(self.hayBales) do
		setVisibility(v, false);
	end;
	
	for i,v in pairs(self.strawBales) do
		setVisibility(v, false);
	end;
	
	self.counter = 0;
	
	local limit = 1;
	for index, item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale) then
			local refx, refy, refz = getWorldTranslation(self.ref);
			local bx, by, bz = getWorldTranslation(item.item.nodeId);
			self.distance = Utils.vector3Length(refx-bx, refy-by, refz-bz);
			if self.distance < limit then
				self.baleId2 = item.item.nodeId;
				break;
			end;
		end;
	end;
	
	setTranslation(self.balesJoint, 0, 0, 6.661);
	self.endGame = true;
	if self.tranprep then
		self.tranprep = false;
	end;
end;

