WorkModeEvent = {};
WorkModeEvent_mt = Class(WorkModeEvent, Event);

InitEventClass(WorkModeEvent, "WorkModeEvent");

function WorkModeEvent:emptyNew()
    local self = Event:new(WorkModeEvent_mt);
    self.className="WorkModeEvent";
    return self;
end;

function WorkModeEvent:new(vehicle, state)
    local self = WorkModeEvent:emptyNew()
    self.vehicle = vehicle;
	self.state = state;
    return self;
end;

function WorkModeEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function WorkModeEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.state);
end;

function WorkModeEvent:run(connection)   
	self.vehicle:WorkMode(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(WorkModeEvent:new(self.vehicle, self.state), nil, connection, self.vehicle);
    end;
end;

function WorkModeEvent.sendEvent(vehicle, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(WorkModeEvent:new(vehicle, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(WorkModeEvent:new(vehicle, state));
		end;
	end;
end;